/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2004 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_SHORTCUTTEXTURE_H__475A4EF6_04DF_4515_8972_CAD443513885__INCLUDED_)
#define AFX_SHORTCUTTEXTURE_H__475A4EF6_04DF_4515_8972_CAD443513885__INCLUDED_

#include "Texture.h"

class ShortcutTexture : public Texture
{
public:
	ShortcutTexture();
	virtual ~ShortcutTexture();

	void configure(const string &images, const string &useAlphaMap);
	bool apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType);
	bool applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count) { return false; };

	bool isTransparencyNeeded() { return transparencyNeeded; };
	bool isAlphaMapNeeded() { return (has_AlphaMap || has_hoverAlphaMap || has_pressedAlphaMap); };

private:

	void PrepareAlphaChannel(HBITMAP &bmp);
	void checkMagicPink(HDC destHDC, int width, int height);

	bool has_AlphaMap;
	bool has_hoverAlphaMap;
	bool has_pressedAlphaMap;

	HDC memoryDC;
	HBITMAP memoryBitmap;

	HDC memoryHoverDC;
	HBITMAP memoryHoverBitmap;

	HDC memoryPressedDC;
	HBITMAP memoryPressedBitmap;

	int imageHeight;
	int imageWidth;

	int hoverimageHeight;
	int hoverimageWidth;

	int pressedimageHeight;
	int pressedimageWidth;

	bool transparencyNeeded;
};

#endif // !defined(AFX_SHORTCUTTEXTURE_H__475A4EF6_04DF_4515_8972_CAD443513885__INCLUDED_)
